/*-----------------------------------------------------------------------*/
/*  LINKER COMMAND FILE - MEMORY SPECIFICATION for C240 et en CPP
/*		for FLASH programmation				                    */
/*-----------------------------------------------------------------------*/
-c                              /* LINK USING C CONVENTIONS              */
-stack 0x040                    /* STACK                                 */
/* -l rts2xx.lib */
/*  -e _c_int0  */

/*-----------------------------------------------------------------------*/
/* LINKER DIRECTIVES                                                     */
/*-----------------------------------------------------------------------*/
MEMORY
{
    PAGE 0: FLASH_F: origin = 0x1000,      length = 0x3000  /* on-chip Flash disponible*/
            PM_F   : origin = 0x8000, length = 0x7e00  /* external PM free */
            B0PM_F : origin = 0xfe00, length = 0x100   /* B0 PM free */
    PAGE 1: REGS   : origin = 0,      length = 0x60    /* memory-mapped regs. */
            INTVEC : origin = 0x60,   length = 0x20    /* DM B2 with int. vectors */
            B0DM_F : origin = 0x200,  length = 0x100   /* DM B0 free */
            M_VARS : origin = 0x300,  length = 0x60    /* DM used by monitor */
            SPS    : origin = 0x360,  length = 0x20    /* stack assigned by monitor */
            B1_F   : origin = 0x380,  length = 0x80    /* B1 free */
						ExtDM	: origin = 0xB800, length = 0x0800	/* external DM free */
/* 						BMCK   : origin = 0xa000, length =0x6000   MCK_DEMO Variables   */
						LOG	: origin = 0xC000, length = 0x2000	/* external DM for logging results */
						REF	: origin = 0xE000, length = 0x0200	/* external DM free */
						SPS1	: origin = 0xE200, length = 0x0800	/* external DM free */

}
SECTIONS
{
    .text:   	{ }     > FLASH_F   PAGE 0
    .cinit:  	{ }     > FLASH_F   PAGE 0
    .switch: 	{ }     > FLASH_F   PAGE 0
    .const:  	{ }     > FLASH_F   PAGE 0
	 table  		{ }     > FLASH_F   PAGE 0 
	 tableRAM  		{ }     > B0DM_F	PAGE 1
    .bss:    	{ }     > B1_F   PAGE 1
    .data:    	load=FLASH_F PAGE 0, run=ExtDM   PAGE 1			 /*nouveau */
	 .sysmem  	{ }     > B1_F   PAGE 1
    .stack:  	{ }     > SPS1  PAGE 1
}

