/*-----------------------------------------------------------------------*/
/*  LINKER COMMAND FILE - MEMORY SPECIFICATION for C240  et en CPP       */
/*-----------------------------------------------------------------------*/
-c                              /* LINK USING C CONVENTIONS              */
-stack 0x040                    /* STACK                                 */
/*  -e _c_int0  */

/*-----------------------------------------------------------------------*/
/* LINKER DIRECTIVES                                                     */
/*-----------------------------------------------------------------------*/
MEMORY
{
    PAGE 0: FLASH  : origin = 0,      length = 0x4000  /* on-chip Flash */
						PM_F   : origin = 0x8000, length = 0x3800  /* external PM free */
            B0PM_F : origin = 0xfe00, length = 0x100   /* B0 PM free */
    PAGE 1: REGS   : origin = 0,      length = 0x60    /* memory-mapped regs. */
            INTVEC : origin = 0x60,   length = 0x20    /* DM B2 with int. vectors */
						B0DM_F : origin = 0x200,  length = 0x100   /* DM B0 free */
            M_VARS : origin = 0x300,  length = 0x60    /* DM used by monitor */
            SPS    : origin = 0x360,  length = 0x20    /* stack assigned by monitor */
            B1_F   : origin = 0x380,  length = 0x80    /* B1 free */
						ExtDM	: origin = 0xB800, length = 0x0800	/* external DM free */
/* 						BMCK   : origin = 0xa000, length =0x6000   MCK_DEMO Variables   */
						LOG	: origin = 0xC000, length = 0x2000	/* external DM for logging results */
						REF	: origin = 0xE000, length = 0x0200	/* external DM free */
						SPS1	: origin = 0xE200, length = 0x0800	/* external DM free */
}
SECTIONS
{
    .text:   	{ }     > PM_F   PAGE 0
    .cinit:  	{ }     > PM_F   PAGE 0
    .switch: 	{ }     > PM_F   PAGE 0
    .const:  	{ }     > PM_F   PAGE 0
    .bss:    	{ }     > B1_F   PAGE 1
    .data:    	load=PM_F PAGE 0, run=ExtDM   PAGE 1			 /*nouveau */
/*    .data:    	load=PM_F PAGE 0, run=B1_F   PAGE 1			*/
	 .sysmem  	{ }     > B1_F   PAGE 1
    .stack:  	{ }     > SPS1  PAGE 1
}

