;****************************************************************************
; File Name   : vects_a.h
; Project     : MCK240 - Motion Control Kit with TMS320F240
; Originator  : A.Sarca
; Description : Header file with interrupt vectors addresses 
;
; Copyright  1997 Technosoft
;
; Last Update   14 Mar 1997
;----------------------------------------------------------------------------
; When INT1-INT6 or NMI are received, the ISR from Flash saves partially the
; context in software stack pointed by AR1 (status registers and ACC), decodes
; the interrupt source then loads in ACC the vector address from data space 
; block B0 and branches with BACC     
;----------------------------------------------------------------------------
rxintvec        .set    B2_SADDR     ; RXINT vector address
txintvec        .set    B2_SADDR+1   ; RXINT vector address
xint1vec        .set    B2_SADDR+2   ; XINT1 vector address
xint2vec        .set    B2_SADDR+3   ; XINT2 vector address
xint3vec        .set    B2_SADDR+4   ; XINT3 vector address
spiintvec       .set    B2_SADDR+5   ; SPIINT vector address
wdtintvec       .set    B2_SADDR+6   ; WDTINT vector address
adcintvec       .set    B2_SADDR+7   ; ADCINT vector address
cmp1intvec      .set    B2_SADDR+8   ; CMP1INT vector address
cmp2intvec      .set    B2_SADDR+0ah ; CMP2INT vector address
cmp3intvec      .set    B2_SADDR+0bh ; CMP3INT vector address
scmp1intvec     .set    B2_SADDR+0ch ; SCMP1INT vector address
scmp2intvec     .set    B2_SADDR+0dh ; SCMP2INT vector address
scmp3intvec     .set    B2_SADDR+0eh ; SCMP3INT vector address
tpint1vec       .set    B2_SADDR+0fh ; TPINT1 vector address
tcint1vec       .set    B2_SADDR+10h ; TCINT1 vector address
tufint1vec      .set    B2_SADDR+11h ; TUFINT1 vector address
tofint1vec      .set    B2_SADDR+12h ; TOFINT1 vector address
tpint2vec       .set    B2_SADDR+13h ; TPINT2 vector address
tcint2vec       .set    B2_SADDR+14h ; TCINT2 vector address
tufint2vec      .set    B2_SADDR+15h ; TUFINT2 vector address
tofint2vec      .set    B2_SADDR+16h ; TOFINT2 vector address
tpint3vec       .set    B2_SADDR+17h ; TPINT3 vector address
tcint3vec       .set    B2_SADDR+18h ; TCINT3 vector address
tufint3vec      .set    B2_SADDR+19h ; TUFINT3 vector address
tofint3vec      .set    B2_SADDR+1ah ; TOFINT3 vector address
capint1vec      .set    B2_SADDR+1bh ; CAPINT1 vector address
capint2vec      .set    B2_SADDR+1ch ; CAPINT2 vector address
capint3vec      .set    B2_SADDR+1dh ; CAPINT3 vector address
capint4vec      .set    B2_SADDR+1eh ; CAPINT4 vector address
pdpintvec       .set    B2_SADDR+1fh ; PDPINT vector address
;----------------------------------------------------------------------------
; When software interrupts are generated, the ISR from Flash loads in ACC
; the vector address from data space block B1 (last 16h locations) and branches
; with BACC. ATTENTION! Save before interrupt call, ACC and set DP=7
;----------------------------------------------------------------------------
B1SVA           .set    B1_SADDR+0e9h 
int8vec         .set    B1SVA        ; (3e9h)
int9vec         .set    B1SVA+1      ; (3eah)
int10vec        .set    B1SVA+2      ; (3ebh)
int11vec        .set    B1SVA+3      ; (3ech)
int12vec        .set    B1SVA+4      ; (3edh)
int13vec        .set    B1SVA+5      ; (3eeh)
int14vec        .set    B1SVA+6      ; (3efh)
int15vec        .set    B1SVA+7      ; (3f0h)
int16vec        .set    B1SVA+8      ; (3f1h)
int20vec        .set    B1SVA+9      ; (3f2h)
int21vec        .set    B1SVA+0ah    ; (3f3h)
int22vec        .set    B1SVA+0bh    ; (3f4h)
int23vec        .set    B1SVA+0ch    ; (3f5h)
int24vec        .set    B1SVA+0dh    ; (3f6h)
int25vec        .set    B1SVA+0eh    ; (3f7h)
int26vec        .set    B1SVA+0fh    ; (3f8h)
int27vec        .set    B1SVA+10h    ; (3f9h)
int28vec        .set    B1SVA+11h    ; (3fah)
int29vec        .set    B1SVA+12h    ; (3fbh)
int30vec        .set    B1SVA+13h    ; (3fch)
int31vec        .set    B1SVA+14h    ; (3fdh)
trapvec         .set    B1SVA+15h    ; (3feh)
nmivec          .set    B1SVA+16h    ; (3ffh)
;****************************************************************************
